import java.io.*;
import java.net.*;
import com.sun.net.httpserver.*;

import java.util.logging.*;


class ListGamesHandler implements HttpHandler {

	private static Logger logger;

    static {
        logger = Logger.getLogger("tickettoride");
    }


	@Override
	public void handle(HttpExchange exchange) throws IOException {
		
		boolean success = false;
	
        logger.entering("ListGamesHandler", "handle");
	
		try {
			if (exchange.getRequestMethod().toLowerCase().equals("get")) {
				
				Headers reqHeaders = exchange.getRequestHeaders();
				if (reqHeaders.containsKey("Authorization")) {
				
					String authToken = reqHeaders.getFirst("Authorization");
					if (authToken.equals("afj232hj2332")) {
					
						String respData = 
							"{ \"game-list\": [" +
								"{ \"name\": \"fhe game\", \"player-count\": 3 }," +
								"{ \"name\": \"work game\", \"player-count\": 4 }," +
								"{ \"name\": \"church game\", \"player-count\": 2 }" +
								"]" +
							"}";
						
						exchange.sendResponseHeaders(HttpURLConnection.HTTP_OK, 0);

						OutputStream respBody = exchange.getResponseBody();
						writeString(respData, respBody);
						respBody.close();
						
						success = true;
					}
				}
			}
			
			if (!success) {
				exchange.sendResponseHeaders(HttpURLConnection.HTTP_BAD_REQUEST, 0);
				exchange.getResponseBody().close();
			}
		}
		catch (IOException e) {
            logger.log(Level.SEVERE, e.getMessage(), e);

			exchange.sendResponseHeaders(HttpURLConnection.HTTP_SERVER_ERROR, 0);
			exchange.getResponseBody().close();
		}
		
        logger.exiting("ListGamesHandler", "handle");
	}
	
	private void writeString(String str, OutputStream os) throws IOException {
		OutputStreamWriter sw = new OutputStreamWriter(os);
		sw.write(str);
		sw.flush();
	}
}
